\ 
\ Last_change: KS 18.01.2012 11:00:08
\ 
\ The example from Berds article in the VD 4/2011, page 29/30 can now be
\ implemented as follows:
\
\ now implemented using simpleOOP by Klaus Schleisiek
\
\ some re-definitions to adapt to Manfred's syntax:

include oop.fs

: msg   polymorphic ;
: m:    : ;
Classroot definitions
: New   Classroot Object ;
: ::    Classroot Attribute ;

Forth definitions

\ The example follows here now:

class aCell aCell definitions 1 cells self allot
\ ----------------------------------------------------
m: @ ( oid -- u ) ( forth ) @ ;
m: ! ( u oid -- ) ( forth ) ! ;


forth definitions

class MemVar MemVar definitions
\ ---------------------------------------------------
aCell :: addr

msg @ ( self -- x )
msg ! ( x self -- )

m: init ( addr self -- ) self addr ! ; \ early binding to aCell !

m: ? ( self -- ) self @ . ; \ late binding to @

m: +! ( x self -- ) dup >r self @ + r> self ! ; \ late binding to @ and !

\ +! will late bind to the following methods when applied to a MemVar

m: ! ( x self -- ) self addr @ ! ;
m: @ ( self -- x ) self addr @ @ ;

forth definitions

: flash! ( x a -- ) ." flash store " ! ; \ a dummy to simulate flash access

MemVar Class FlashVar  FlashVar definitions
\ ---------------------------------------------
m: ! ( x self -- ) self addr @ flash! ;
\ This method is early bound to a FlashVar Instance but late bound to the +!
\ and ? methods defined in MemVar, when those are applied to a FlashVar
\ Instance.


forth definitions

: spi! ( x a -- ) ." spi store " ! ; \ a dummy to simulate write access
: spi@ ( a -- x ) ." spi fetch " @ ; \ a dummy to simulate read access

MemVar Class SpiVar SpiVar definitions
\ ---------------------------------------------
m: ! ( x self -- ) self addr @ spi! ;
m: @ ( self -- x ) self addr @ spi@ ;
\ This methods are early bound to a SpiVar Instance but late bound to the +!
\ and ? methods defined in MemVar, when those are applied to a SpiVar
\ Instance.


forth definitions

\ Some test code to see that late binding in '?' and '+!' really works:

MemVar new a here 0 , a init
SpiVar new b here 1 , b init
FlashVar new c here 2 , c init

cr
cr ." a ? should print: 0"
cr ." " a ?
cr ." b ? should print: spi fetch 1"
cr ." " b ?
cr ." c ? should print: 2"
cr ." " c ?
cr
cr ." 100 a +! a ? should print: 100"
cr ." " 100 a +! a ?
cr ." 200 b +! b ? should print: spi fetch spi store spi fetch 201"
cr ." " 200 b +! b ?
cr
cr ." 300 c +! c ? should print: flash store 302"
cr ." " 300 c +! c ?

